summaryrefslogtreecommitdiffstats
path: root/system/mongodb/mongodb.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'system/mongodb/mongodb.SlackBuild')
-rw-r--r--system/mongodb/mongodb.SlackBuild100
1 files changed, 72 insertions, 28 deletions
diff --git a/system/mongodb/mongodb.SlackBuild b/system/mongodb/mongodb.SlackBuild
index 57e9b2dfd4..7bcc41e901 100644
--- a/system/mongodb/mongodb.SlackBuild
+++ b/system/mongodb/mongodb.SlackBuild
@@ -3,6 +3,7 @@
# Slackware build script for MongoDB
# Copyright 2015 Miguel De Anda <miguel@thedeanda.com>
+# Copyright 2023-2024 Willy Sudiarto Raharjo <willysr@slackbuilds.org>
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
@@ -26,11 +27,10 @@
cd $(dirname $0) ; CWD=$(pwd)
PRGNAM="mongodb"
-VERSION=${VERSION:-3.4.24}
+VERSION=${VERSION:-7.0.8}
BUILD=${BUILD:-1}
TAG=${TAG:-_SBo}
PKGTYPE=${PKGTYPE:-tgz}
-MAKEJOBS=${MAKEJOBS:-1}
if [ -z "$ARCH" ]; then
case "$( uname -m )" in
@@ -40,9 +40,6 @@ if [ -z "$ARCH" ]; then
esac
fi
-# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
-# the name of the created package would be, and then exit. This information
-# could be useful to other scripts.
if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
exit 0
@@ -58,12 +55,18 @@ MONGO_GROUP=${MONGO_GROUP:-285}
SRC_FILE=$PRGNAM-src-r$VERSION.tar.gz
SRC_FLDR=$PRGNAM-src-r$VERSION
-set -e
+if [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
-# Bail if user or group isn't valid on your system
-if ! getent passwd mongo 1>/dev/null 2>/dev/null; then
+set -e
-cat << EOF
+bailout() {
+ cat << EOF
You must have a mongo user to run this script
@@ -71,53 +74,94 @@ cat << EOF
# useradd -u $MONGO_USER -d /var/lib/$PRGNAM -s /bin/false -g mongo mongo
EOF
+ exit 1
+}
- exit
-elif ! getent group mongo 1>/dev/null 2>/dev/null; then
-
-cat << EOF
-
- You must have a mongo group to run this script
- # groupadd -g $MONGO_GROUP mongo
-
-EOF
- exit
-fi
+# Bail if user or group isn't valid on your system
+getent passwd mongo &>/dev/null || bailout
+getent group mongo &>/dev/null || bailout
rm -fr $TMP/$SRC_FLDR $PKG
mkdir -p $TMP $PKG $OUTPUT
cd $TMP
tar xvf $CWD/$SRC_FILE
cd $SRC_FLDR
-chown -R root.root .
+# remove bundled libs
+rm -fR src/third_party/{boost,pcre-*,snappy-*,yaml-cpp,zlib-*}
+# remove compass
+rm -fR src/mongo/installer/compass
+chown -R root:root .
find -L . \
\( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
-o -perm 511 \) -exec chmod 755 {} \; -o \
\( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
-o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+# thanks gentoo, also for these patches
+for i in $CWD/patches/* ; do patch -p1 < $i ; done
+
+sed -i "s|GCC 11.3|GCC 11.2|g" SConstruct
+sed -i "s|__GNUC_MINOR__ < 3|__GNUC_MINOR__ < 2|g" SConstruct
+
+scons_opts=(
+ --disable-warnings-as-errors
+ --use-system-boost
+ --use-system-pcre2
+ --use-system-snappy
+ --use-system-yaml
+ --use-system-zlib
+ --use-system-zstd
+ --use-sasl-client
+ --use-system-libbson
+ --use-system-mongo-c
+ --ssl
+)
+
+# Thanks to Lockywolf
+# scons can use multiple jobs. For convenience, read MAKEFLAGS from the environment, if set
+JOBS="$( echo $MAKEFLAGS | sed 's,.*-j *\([0-9][0-9]*\)*.*,\1,' )"
+# or if no MAKEFLAGS, use the number of cores minus 1
+JOBS="${JOBS:-$(( $( nproc ) - 1 ))}"
+# or 1, if we really have one core
+[ "$JOBS" = "0" ] && JOBS=1
+
if [ "$ARCH" = "x86_64" ]; then
- scons -j $MAKEJOBS --ssl --disable-warnings-as-errors --prefix=${PKG}/usr core install
+ PREFIX=${PKG}/usr CFLAGS="$SLKCFLAGS" CXXFLAGS="$SLKCFLAGS" LDFLAGS="-L /lib$LIBDIRSUFFIX -L/usr/lib$LIBDIRSUFFIX" \
+ ./buildscripts/scons.py "${scons_opts[@]}" --force-jobs --jobs="$JOBS" install-core
else
- scons -j $MAKEJOBS --ssl --disable-warnings-as-errors --prefix=${PKG}/usr core --wiredtiger=off install
+ PREFIX=${PKG}/usr CFLAGS="$SLKCFLAGS" CXXFLAGS="$SLKCFLAGS" LDFLAGS="-L /lib$LIBDIRSUFFIX -L/usr/lib$LIBDIRSUFFIX" \
+ ./buildscripts/scons.py "${scons_opts[@]}" --force-jobs --jobs="$JOBS" --wiredtiger=off install-core
fi
+# manual install
+( cd build/install/bin
+ for i in * ; do install -D -m 0755 $i $PKG/usr/bin/$i ; done )
+( cd debian
+ for i in *.1 ; do install -D -m 0644 $i $PKG/usr/man/man1/$i ; done )
+
find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
| cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
mkdir -p ${PKG}/usr/doc/${PRGNAM}-${VERSION}
cp distsrc/* ${PKG}/usr/doc/${PRGNAM}-${VERSION}
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
-mkdir -p $PKG/etc/rc.d
-cat $CWD/rc.mongodb > $PKG/etc/rc.d/rc.mongodb.new
+mkdir -p $PKG/etc/{logrotate,rc}.d
+cat $CWD/files/mongodb.conf > $PKG/etc/mongodb.conf.new
+cat $CWD/files/mongos.conf > $PKG/etc/mongos.conf.new
+cat $CWD/files/mongodb.logrotate > $PKG/etc/logrotate.d/mongodb.new
+cat $CWD/files/rc.mongodb > $PKG/etc/rc.d/rc.mongodb.new
+
+mkdir -p $PKG/var/{lib,log}/mongodb
+chmod 750 $PKG/var/{lib,log}/mongodb
+chown mongo:mongo $PKG/var/{lib,log}/mongodb
mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc
cat $CWD/doinst.sh > $PKG/install/doinst.sh
-mkdir -p $PKG/var/lib/mongodb
-chown mongo.mongo $PKG/var/lib/mongodb
-
cd $PKG
/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE